Subject: Re: Expose bond_xmit_hash function

From: Leon Romanovsky <[email-masked]>
Date: Wed, 15 Jan 2020 14:33:23 +0000

On Wed, Jan 15, 2020 at 03:15:35PM +0100, Jiri Pirko wrote:
> Wed, Jan 15, 2020 at 02:04:49PM CET, [email-masked] wrote:
> >
> >On 1/15/2020 11:45 AM, Jiri Pirko wrote:
> >> Wed, Jan 15, 2020 at 09:01:43AM CET, [email-masked] wrote:
> >>> RDMA over Converged Ethernet (RoCE) is a standard protocol which enables
> >>> RDMA’s efficient data transfer over Ethernet networks allowing transport
> >>> offload with hardware RDMA engine implementation.
> >>> The RoCE v2 protocol exists on top of either the UDP/IPv4 or the
> >>> UDP/IPv6 protocol:
> >>>
> >>> --------------------------------------------------------------
> >>> | L2 | L3 | UDP |IB BTH | Payload| ICRC | FCS |
> >>> --------------------------------------------------------------
> >>>
> >>> When a bond LAG netdev is in use, we would like to have the same hash
> >>> result for RoCE packets as any other UDP packets, for this purpose we
> >>> need to expose the bond_xmit_hash function to external modules.
> >>> If no objection, I will push a patch that export this symbol.
> >> I don't think it is good idea to do it. It is an internal bond function.
> >> it even accepts "struct bonding *bond". Do you plan to push netdev
> >> struct as an arg instead? What about team? What about OVS bonding?
> >
> >No, I am planning to pass the bond struct as an arg. Currently, team
>
> Hmm, that would be ofcourse wrong, as it is internal bonding driver
> structure.
>
>
> >bonding is not supported in RoCE LAG and I don't see how OVS is related.
>
> Should work for all. OVS is related in a sense that you can do bonding
> there too.
>
>
> >
> >>
> >> Also, you don't really need a hash, you need a slave that is going to be
> >> used for a packet xmit.
> >>
> >> I think this could work in a generic way:
> >>
> >> struct net_device *master_xmit_slave_get(struct net_device *master_dev,
> >> 					 struct sk_buff *skb);
> >
> >The suggestion is to put this function in the bond driver and call it
> >instead of bond_xmit_hash? is it still necessary if I have the bond pointer?
>
> No. This should be in a generic code. No direct calls down to bonding
> driver please. Or do you want to load bonding module every time your
> module loads?
>
> I thinks this can be implemented with ndo with "master_xmit_slave_get()"
> as a wrapper. Masters that support this would just implement the ndo.

We are talking about code sharing and not attempting to solve any
problem other than that.

Right now, we have one of two options:
1. One-to-one copy/paste of that bond_xmit function to RDMA.
2. Add EXPORT_SYMBOL and call from RDMA.

Do you have another solution to our undesire to do copy/paste in mind?

Thanks